//////////////////////////////////////////////////////////////////////////
//	"sc_preventallowmedium.cpp"
//------------------------------------------------------------------------
//	$Id: sc_preventallowmedium.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#ifdef	HAVE_CONFIG_H
#	include	"../config.h"
#	undef	HAVE_CONFIG_H
#endif
#include	"devctl.h"

int		DevCtl::ScsiPreventAllowMediumRemoval(int pathId, int targetId, int lun, unsigned state)
{
	Sgt		sgt;

	if ( this->fd < 0 || this->htype != HT_SG )
		return -1;
	for (;;)
	{
		memset(&sgt, 0, sizeof(sgt));
		sgt.fd                  = this->fd;
		sgt.hdr.interface_id    = 'S';
		sgt.hdr.dxfer_direction = SG_DXFER_NONE;
		sgt.hdr.cmd_len         = SCSI_CDB6_LEN;
	//	sgt.hdr.iovec_count     = 0;
		sgt.hdr.mx_sb_len       = SCSI_SENSE_LEN;
	//	sgt.hdr.dxfer_len       = 0;
	//	sgt.hdr.dxferp          = NULL;
		sgt.hdr.cmdp            = sgt.cdb;
		sgt.hdr.sbp             = sgt.sense;
		sgt.hdr.timeout         = this->scsi_timeout;
	//	sgt.hdr.flags           = 0;
	//	sgt.hdr.pack_id         = 0;
	//	sgt.hdr.usr_ptr         = NULL;
		sgt.cdb[0]              = 0x1E; // PREVENT ALLOW MEDIUM REMOVAL
		sgt.cdb[1]              = lun << 5;
	//	sgt.cdb[2]              = 0;
	//	sgt.cdb[3]              = 0;
		sgt.cdb[4]              = state;
	//	sgt.cdb[5]              = 0;
		if ( ioctl(sgt.fd, SG_IO, &sgt.hdr) < 0 )
			return -1; // error
		if ( (sgt.hdr.info & SG_INFO_OK_MASK) != SG_INFO_OK )
		{
			if ( sgt.hdr.sb_len_wr > 0 && this->ScsiCheckCondition(sgt) > 0 )
				continue;	// retry
			return -1;
		} else
			return sgt.hdr.resid;	// OK
	}
}
