/*************************************************************************
*	"sb8crc.h"
*-------------------------------------------------------------------------
*	$Id: sb8crc.h 94 2006-09-20 08:51:21Z taro $
*************************************************************************/
#ifndef SB8CRC_H_INCLUDED
#define SB8CRC_H_INCLUDED
#ifdef __cplusplus
extern "C"
{
#endif

typedef unsigned int	sb8crc_t;

typedef struct sb8crcwork_tag
{
	sb8crc_t	r;
} Sb8crcwork;

extern void	sb8crc_init(Sb8crcwork * crcwork);
extern void	sb8crc_calc(Sb8crcwork * crcwork, int size, const void * data);
extern sb8crc_t	sb8crc_getcrc(Sb8crcwork * crcwork);
extern void	sb8crc_term(Sb8crcwork * crcwork);

#ifdef __cplusplus
}
#endif
#endif
