//////////////////////////////////////////////////////////////////////////
//	"dev_getfilesize.cpp"
//------------------------------------------------------------------------
//	$Id: dev_getfilesize.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"devctl.h"

#if defined(_DEBUG)
# include	<crtdbg.h>
# include	<stdio.h>
# define	DBGREPORT(param_)	_CrtDbgReport param_
# define	DBGPRINT(param_)	printf param_
#else
# define	DBGREPORT(param_)
# define	DBGPRINT(param_)
#endif

DevCtl::INT64	DevCtl::GetFileSize(void)
{
	LARGE_INTEGER	size;

	if ( this->GetFileSize(size) < 0 )
		return -1I64;
	return size.QuadPart;
}

int		DevCtl::GetFileSize(LARGE_INTEGER & size)
{
	DBGPRINT(("DevCtl::GetFileSize()\n"));
	if ( this->handle == NULL )
		return -1;
	if ( ::GetFileSizeEx(this->handle, &size) == 0 )
		return -1;
	DBGPRINT(("    filesize = %I64d\n", size.QuadPart));
	return 0;
}
