//////////////////////////////////////////////////////////////////////////
//	"sc_getdevicetype.cpp"
//------------------------------------------------------------------------
//	$Id: sc_getdevicetype.cpp 92 2006-09-19 22:07:05Z taro $
//////////////////////////////////////////////////////////////////////////

#ifdef	HAVE_CONFIG_H
#	include	"../config.h"
#	undef	HAVE_CONFIG_H
#endif

#if	defined(WIN32)
# include	<windows.h>
# include	<stddef.h>
# include	<stdio.h>
# include	<tchar.h>
# include	"devctl.h"
#elif	defined(LINUX)
# include	"../linux/devctl.h"
#endif

TCHAR *	DevCtl::ScsiGetDeviceType(unsigned devType, TCHAR * buffer)
{
	TCHAR		*s;

	switch ( devType & 0x1F )
	{
		case 0x00: return TEXT("Direct access device" );
		case 0x01: return TEXT("Sequential device"    );
		case 0x02: return TEXT("Printer device"       );
		case 0x03: return TEXT("Processor device"     );
		case 0x04: return TEXT("Write-once device"    );
		case 0x05: return TEXT("CD/DVD-ROM device"    );
		case 0x06: return TEXT("Scaner device"        );
		case 0x07: return TEXT("Optical memory device");
		case 0x08: return TEXT("Medium changer device");
		case 0x09: return TEXT("Communication device" );
		case 0x0C: return TEXT("Storage array device" );
		case 0x0D: return TEXT("Enclosure services d.");
		case 0x0E: return TEXT("Simplified D-A device");
		case 0x0F: return TEXT("Optical card r/w dev.");
		default  :
			if ( buffer == NULL )
				return TEXT("Unkown");
			_stprintf(buffer, TEXT("Unkown %02X"), devType & 0x1F);
			return buffer;
	}
	return s;
}

