//////////////////////////////////////////////////////////////////////////
//	"sc_passthroughdirect.cpp"
//------------------------------------------------------------------------
//	$Id: sc_passthroughdirect.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	"devctl.h"


int		DevCtl::ScsiPassThroughDirect(unsigned insize, SCSI_PASS_THROUGH_DIRECT * inspt, unsigned outsize, SCSI_PASS_THROUGH_DIRECT * outspt)
{
	DWORD	dwSize;

#if	defined(DEVCTL_USE_MD4RNET)
	if ( this->IsNetDevice() )
	{
		return this->NetScsiCommand(insize, inspt, outsize, outspt);
	}
#endif
	if ( this->DeviceIoControl(IOCTL_SCSI_PASS_THROUGH_DIRECT, (void *)inspt, insize, (void *)outspt, outsize, &dwSize) == 0 )
		return -1;
	return (int)dwSize;
}

